<?php
require_once './dbconnection.php';

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    if (isset($_POST['userid']) && isset($_POST['connectionuserid']) && !empty($_POST['userid']) && !empty($_POST['connectionuserid'])) {
        
        $userid = strip_tags(mysqli_real_escape_string($conn, $_POST['userid']));
        $connectionuserid = strip_tags(mysqli_real_escape_string($conn, $_POST['connectionuserid']));
        $status = "connected";

        // First, check if both user_id and connection_user_id exist in the register table
        $query = "SELECT id, sendconnectionreq, receiveconnectionreq FROM register WHERE id = '$userid' OR id = '$connectionuserid'";
        $result = mysqli_query($conn, $query);

        if (mysqli_num_rows($result) > 0) {
            // Fetch both user records
            $userRecords = [];
            while ($row = mysqli_fetch_assoc($result)) {
                $userRecords[$row['id']] = $row;
            }

            // Ensure that we have both records for user_id and connectionuserid
            if (isset($userRecords[$userid]) && isset($userRecords[$connectionuserid])) {
                $userRecord = $userRecords[$userid];
                $connectionRecord = $userRecords[$connectionuserid];

                // Remove user_id and connectionuserid from sendconnectionreq and receiveconnectionreq
                // For the first user (user_id)
                if (!empty($userRecord['sendconnectionreq'])) {
                    $sendArray = explode(",", $userRecord['sendconnectionreq']);
                    $sendArray = array_diff($sendArray, array($userid, $connectionuserid)); // Remove both ids
                    $updatedSendConnectionReqs = implode(",", $sendArray);
                    $updateQuery = "UPDATE register SET sendconnectionreq = '$updatedSendConnectionReqs' WHERE id = '$userid'";
                    mysqli_query($conn, $updateQuery);
                }

                if (!empty($userRecord['receiveconnectionreq'])) {
                    $receiveArray = explode(",", $userRecord['receiveconnectionreq']);
                    $receiveArray = array_diff($receiveArray, array($userid, $connectionuserid)); // Remove both ids
                    $updatedReceiveConnectionReqs = implode(",", $receiveArray);
                    $updateQuery = "UPDATE register SET receiveconnectionreq = '$updatedReceiveConnectionReqs' WHERE id = '$userid'";
                    mysqli_query($conn, $updateQuery);
                }

                // For the second user (connectionuserid)
                if (!empty($connectionRecord['sendconnectionreq'])) {
                    $sendArray = explode(",", $connectionRecord['sendconnectionreq']);
                    $sendArray = array_diff($sendArray, array($userid, $connectionuserid)); // Remove both ids
                    $updatedSendConnectionReqs = implode(",", $sendArray);
                    $updateQuery = "UPDATE register SET sendconnectionreq = '$updatedSendConnectionReqs' WHERE id = '$connectionuserid'";
                    mysqli_query($conn, $updateQuery);
                }

                if (!empty($connectionRecord['receiveconnectionreq'])) {
                    $receiveArray = explode(",", $connectionRecord['receiveconnectionreq']);
                    $receiveArray = array_diff($receiveArray, array($userid, $connectionuserid)); // Remove both ids
                    $updatedReceiveConnectionReqs = implode(",", $receiveArray);
                    $updateQuery = "UPDATE register SET receiveconnectionreq = '$updatedReceiveConnectionReqs' WHERE id = '$connectionuserid'";
                    mysqli_query($conn, $updateQuery);
                }

               
                $insertQuery = "INSERT INTO connections (user_id, connectionuserid, status) VALUES ('$userid', '$connectionuserid', '$status')";
                if (mysqli_query($conn, $insertQuery)) {
                    $response = array(
                        "ResponseCode" => "200",
                        "Result" => "true",
                        "ResponseMsg" => "New Connection has been added"
                    );
                    echo json_encode($response);
                } else {
                    // Error inserting into the connections table
                    $response = array(
                        "ResponseCode" => "500",
                        "Result" => "false",
                        "ResponseMsg" => "Error inserting into connections table."
                    );
                    echo json_encode($response);
                }
            } else {
                // One or both users not found
                $response = array("ResponseCode" => "404", "Result" => "false", "ResponseMsg" => "User or connection not found in the register table.");
                echo json_encode($response);
            }
        } else {
            // No records found for the provided user_id and connection_user_id
            $response = array("ResponseCode" => "404", "Result" => "false", "ResponseMsg" => "User or connection not found.");
            echo json_encode($response);
        }
    } else {
        // Missing parameters
        $response = array("ResponseCode" => "401", "Result" => "false", "ResponseMsg" => "User ID and Connection User ID are required.");
        echo json_encode($response);
    }
} else {
    // Method not allowed
    $response = array("ResponseCode" => "405", "Result" => "false", "ResponseMsg" => "Method not allowed. Only POST requests are allowed.");
    echo json_encode($response);
}
?>
