<?php
require_once './dbconnection.php';

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    if (isset($_POST['userid']) && !empty($_POST['userid'])) {
        $userid = strip_tags(mysqli_real_escape_string($conn, $_POST['userid']));

        // Step 1: Fetch the receiveconnectionreq column for the given user
        $query = "SELECT receiveconnectionreq FROM register WHERE id = '$userid'";
        $result = mysqli_query($conn, $query);

        if (mysqli_num_rows($result) > 0) {
            $row = mysqli_fetch_assoc($result);
            $receiveConnectionReqs = $row['receiveconnectionreq'];

            // Step 2: If receiveconnectionreq is not empty, split it by commas to get an array of IDs
            if (!empty($receiveConnectionReqs)) {
                $receiveArray = explode(",", $receiveConnectionReqs);
                
                // Step 3: Fetch user data for each ID in the receiveconnectionreq list
                $receiveIds = implode(",", $receiveArray); // Create a comma-separated string of user IDs
                $query = "SELECT * FROM register WHERE id IN ($receiveIds)";
                $result = mysqli_query($conn, $query);

                if (mysqli_num_rows($result) > 0) {
                    $users = array();
                    while ($row = mysqli_fetch_assoc($result)) {
                        $users[] = $row;
                    }
                    $response = array(
                        "ResponseCode" => "200",
                        "Result" => "true",
                        "ResponseMsg" => "Users fetched successfully.",
                        "Data" => $users
                    );
                    echo json_encode($response);
                } else {
                    $response = array("ResponseCode" => "404", "Result" => "false", "ResponseMsg" => "No users found in receiveconnectionreq.");
                    echo json_encode($response);
                }
            } else {
                $response = array("ResponseCode" => "404", "Result" => "false", "ResponseMsg" => "No connections in receiveconnectionreq.");
                echo json_encode($response);
            }
        } else {
            $response = array("ResponseCode" => "404", "Result" => "false", "ResponseMsg" => "User not found.");
            echo json_encode($response);
            exit;
        }
    } else {
        $response = array("ResponseCode" => "401", "Result" => "false", "ResponseMsg" => "User ID is required.");
        echo json_encode($response);
    }
} else {
    $response = array("ResponseCode" => "405", "Result" => "false", "ResponseMsg" => "Method not allowed. Only POST requests are allowed.");
    echo json_encode($response);
}
?>
