<?php
require_once './dbconnection.php';

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    if (isset($_POST['userid']) && !empty($_POST['userid'])) {
        $userid = strip_tags(mysqli_real_escape_string($conn, $_POST['userid']));

        // Step 1: Fetch the sendconnectionreq and receiveconnectionreq of the user
        $query = "SELECT sendconnectionreq, receiveconnectionreq FROM register WHERE id = '$userid'";
        $result = mysqli_query($conn, $query);

        if (mysqli_num_rows($result) > 0) {
            $row = mysqli_fetch_assoc($result);
            $sendConnectionReqs = $row['sendconnectionreq'];
            $receiveConnectionReqs = $row['receiveconnectionreq'];

            // Step 2: Create an array of all user IDs from sendconnectionreq and receiveconnectionreq
            $excludedUsers = array();
            if (!empty($sendConnectionReqs)) {
                $sendArray = explode(",", $sendConnectionReqs);
                $excludedUsers = array_merge($excludedUsers, $sendArray);
            }
            if (!empty($receiveConnectionReqs)) {
                $receiveArray = explode(",", $receiveConnectionReqs);
                $excludedUsers = array_merge($excludedUsers, $receiveArray);
            }

            // Step 3: Add the provided user ID to the exclusion list
            $excludedUsers[] = $userid;

            // Step 4: Build the exclusion condition for the query
            $excludedUsers = array_unique($excludedUsers); // Remove duplicate IDs
            $excludedUserIds = implode(",", $excludedUsers);

            // Step 5: Fetch all users excluding those in the exclusion list
            $query = "SELECT * FROM register WHERE id NOT IN ($excludedUserIds)";
            $result = mysqli_query($conn, $query);

            if (mysqli_num_rows($result) > 0) {
                $users = array();
                while ($row = mysqli_fetch_assoc($result)) {
                    $users[] = $row;
                }
                $response = array(
                    "ResponseCode" => "200",
                    "Result" => "true",
                    "ResponseMsg" => "Users fetched successfully.",
                    "Data" => $users
                );
                echo json_encode($response);
            } else {
                $response = array("ResponseCode" => "404", "Result" => "false", "ResponseMsg" => "No users found.");
                echo json_encode($response);
            }
        } else {
            $response = array("ResponseCode" => "404", "Result" => "false", "ResponseMsg" => "User not found.");
            echo json_encode($response);
            exit;
        }
    } else {
        $response = array("ResponseCode" => "401", "Result" => "false", "ResponseMsg" => "User ID is required.");
        echo json_encode($response);
    }
} else {
    $response = array("ResponseCode" => "405", "Result" => "false", "ResponseMsg" => "Method not allowed. Only POST requests are allowed.");
    echo json_encode($response);
}
?>
