<?php
require_once './dbconnection.php';

header('Content-Type: application/json');

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    if (isset($_POST['connectionid']) && !empty($_POST['connectionid'])) {
        $connectionid = strip_tags(mysqli_real_escape_string($conn, $_POST['connectionid']));
        $userid = isset($_POST['userid']) ? strip_tags(mysqli_real_escape_string($conn, $_POST['userid'])) : null;

        if (empty($userid)) {
            $response = array("ResponseCode" => "401", "Result" => "false", "ResponseMsg" => "User ID is required.");
            echo json_encode($response);
            exit;
        }

        $query = "SELECT sendconnectionreq FROM register WHERE id = '$userid'";
        $result = mysqli_query($conn, $query);

        if (mysqli_num_rows($result) > 0) {
            $row = mysqli_fetch_assoc($result);
            $currentSendConnections = $row['sendconnectionreq'];

            if (!empty($currentSendConnections)) {
                $sendConnectionsArray = explode(",", $currentSendConnections);
                if (in_array($connectionid, $sendConnectionsArray)) {
                    $response = array("ResponseCode" => "200", "Result" => "true", "ResponseMsg" => "Connection already exists.");
                    echo json_encode($response);
                    exit;
                }
                $updatedSendConnections = $currentSendConnections . "," . $connectionid;
            } else {
                $updatedSendConnections = $connectionid;
            }
        } else {
            $response = array("ResponseCode" => "404", "Result" => "false", "ResponseMsg" => "User not found.");
            echo json_encode($response);
            exit;
        }

        $queryReceive = "SELECT receiveconnectionreq FROM register WHERE id = '$connectionid'";
        $resultReceive = mysqli_query($conn, $queryReceive);

        if (mysqli_num_rows($resultReceive) > 0) {
            $rowReceive = mysqli_fetch_assoc($resultReceive);
            $currentReceiveConnections = $rowReceive['receiveconnectionreq'];

            if (!empty($currentReceiveConnections)) {
                $receiveConnectionsArray = explode(",", $currentReceiveConnections);
                if (!in_array($userid, $receiveConnectionsArray)) {
                    $updatedReceiveConnections = $currentReceiveConnections . "," . $userid;
                } else {
                    $updatedReceiveConnections = $currentReceiveConnections;
                }
            } else {
                $updatedReceiveConnections = $userid;
            }

            $updateQuery = "UPDATE register SET sendconnectionreq = '$updatedSendConnections' WHERE id = '$userid'";
            $updateReceiveQuery = "UPDATE register SET receiveconnectionreq = '$updatedReceiveConnections' WHERE id = '$connectionid'";

            if (mysqli_query($conn, $updateQuery) && mysqli_query($conn, $updateReceiveQuery)) {
                $response = array(
                    "ResponseCode" => "200",
                    "Result" => "true",
                    "ResponseMsg" => "Connection request added successfully."
                );
                echo json_encode($response);
            } else {
                $response = array("ResponseCode" => "500", "Result" => "false", "ResponseMsg" => "Error while updating the connections.");
                echo json_encode($response);
            }
        } else {
            $response = array("ResponseCode" => "404", "Result" => "false", "ResponseMsg" => "Connection ID not found.");
            echo json_encode($response);
            exit;
        }
    } else {
        $response = array("ResponseCode" => "401", "Result" => "false", "ResponseMsg" => "Connection ID is required.");
        echo json_encode($response);
    }
} else {
    $response = array("ResponseCode" => "405", "Result" => "false", "ResponseMsg" => "Method not allowed. Only POST requests are allowed.");
    echo json_encode($response);
}
?>
